#ifndef _checkLicense_
#define _checkLicense_

#include "../Includes/windefs.h"
#include "../SMemory/SBlocks.h"
#include "../x509pkts/x509_structs.h"

extern const char *szBeginMSG;
extern const char *szSignature;
extern const char *szEndMSG;

extern const char *szBase64BlockStart;
extern const char *szBase64BlockEnd;

extern const char *szPKStart;
extern const char *szPKEnd;

extern const char *cl_szLicenseSubjectBestCryptWindows;
extern const char *cl_szLicenseSubjectBCWipeWindows;
extern const char *cl_szLicenseSubjectBestCryptLinux;
extern const char *cl_szLicenseSubjectBCWipeLinux;
extern const char *cl_szLicenseSubjectCryptoSwap;
extern const char *cl_szLicenseSubjectFireWall;
extern const char *cl_szLicenseSubjectBCArchive;
extern const char *cl_szLicenseSubjectBCWipeTWO;
extern const char *cl_szLicenseSubjectVE;
extern const char *cl_szLicenseSubjectBestCryptMAC;
extern const char *cl_szLicenseSubjectBCWipeMAC;

extern const char *cl_szNumberOfYears;
extern const char *cl_szLicenseBestCryptWindows;
extern const char *cl_szLicenseBCWipeWindows;
extern const char *cl_szLicenseBestCryptLinux;
extern const char *cl_szLicenseBCWipeLinux;
extern const char *cl_szLicenseCryptoSwap;
extern const char *cl_szLicenseFireWall;
extern const char *cl_szLicenseBCArchive;
extern const char *cl_szLicenseBCArchiveW; // rudiment
extern const char *cl_szLicenseBCWipeTWO;
extern const char *cl_szLicenseVE;
extern const char *cl_szLicenseBestCryptMAC;
extern const char *cl_szLicenseBCWipeMAC;

extern const char *cl_szUnitBestCryptWindows;
extern const char *cl_szUnitBCWipeWindows;
extern const char *cl_szUnitBestCryptLinux;
extern const char *cl_szUnitBCWipeLinux;
extern const char *cl_szUnitCryptoSwap;
extern const char *cl_szUnitFireWall;
extern const char *cl_szUnitBCArchive;
extern const char *cl_szUnitBCWipeTWO;
extern const char *cl_szUnitVE;
extern const char *cl_szUnitBestCryptMAC;
extern const char *cl_szUnitBCWipeMAC;

extern const char *cl_szLicenseBestCryptWindowsUpgrade;
extern const char *cl_szLicenseBCWipeWindowsUpgrade;
extern const char *cl_szLicenseBestCryptLinuxUpgrade;
extern const char *cl_szLicenseBCWipeLinuxUpgrade;
extern const char *cl_szLicenseCryptoSwapUpgrade;
extern const char *cl_szLicenseFireWallUpgrade;
extern const char *cl_szLicenseBCArchiveUpgrade;
extern const char *cl_szLicenseBCWipeTWOUpgrade;
extern const char *cl_szLicenseVEUpgrade;
extern const char *cl_szLicenseBestCryptMACUpgrade;
extern const char *cl_szLicenseBCWipeMACUpgrade;

extern const char *cl_szIncludesUpgradedBestCryptWindows;
extern const char *cl_szIncludesUpgradedBCWipeWindows;
extern const char *cl_szIncludesUpgradedBestCryptLinux;
extern const char *cl_szIncludesUpgradedBCWipeLinux;
extern const char *cl_szIncludesUpgradedCryptoSwap;
extern const char *cl_szIncludesUpgradedFireWall;
extern const char *cl_szIncludesUpgradedBCArchive;
extern const char *cl_szIncludesUpgradedBCWipeTWO;
extern const char *cl_szIncludesUpgradedVE;
extern const char *cl_szIncludesUpgradedBestCryptMAC;
extern const char *cl_szIncludesUpgradedBCWipeMAC;

extern const char *cl_szLicenseSubjectForBestCryptWindows;
extern const char *cl_szLicenseSubjectForBCWipeWindows;
extern const char *cl_szLicenseSubjectForBestCryptLinux;
extern const char *cl_szLicenseSubjectForBCWipeLinux;
extern const char *cl_szLicenseSubjectForCryptoSwap;
extern const char *cl_szLicenseSubjectForFireWall;
extern const char *cl_szLicenseSubjectForBCArchive;
extern const char *cl_szLicenseSubjectForBCWipeTWO;
extern const char *cl_szLicenseSubjectForVE;
extern const char *cl_szLicenseSubjectForBestCryptMAC;
extern const char *cl_szLicenseSubjectForBCWipeMAC;

extern const char *cl_szLicenseSubject_Ver2_BestCryptWindows;
extern const char *cl_szLicenseSubject_Ver2_BCWipeWindows;
extern const char *cl_szLicenseSubject_Ver2_BestCryptLinux;
extern const char *cl_szLicenseSubject_Ver2_BCWipeLinux;
extern const char *cl_szLicenseSubject_Ver2_CryptoSwap;
extern const char *cl_szLicenseSubject_Ver2_FireWall;
extern const char *cl_szLicenseSubject_Ver2_BCArchive;
extern const char *cl_szLicenseSubject_Ver2_BCWipeTWO;
extern const char *cl_szLicenseSubject_Ver2_VE;
extern const char *cl_szLicenseSubject_Ver2_BestCryptMAC;
extern const char *cl_szLicenseSubject_Ver2_BCWipeMAC;

extern const char *cl_szLicenseSubject_Ver2_BestCryptCorporate;

extern const char *cl_szBestCryptWindowsRenewal;
extern const char *cl_szBCWipeWindowsRenewal;
extern const char *cl_szBestCryptLinuxRenewal;
extern const char *cl_szBCWipeLinuxRenewal;
extern const char *cl_szCryptoSwapRenewal;
extern const char *cl_szFireWallRenewal;
extern const char *cl_szBCArchiveRenewal;
extern const char *cl_szBCWipeTWORenewal;
extern const char *cl_szVERenewal;
extern const char *cl_szBestCryptMACRenewal;
extern const char *cl_szBCWipeMACRenewal;

extern const char *cl_szBestCryptCorporateRenewal;

extern const char *cl_szVersion;
extern const char *cl_szExpirationDate;
extern const char *cl_szDate;
extern const char *cl_szCreationDate;
extern const char *cl_szCodePage;
extern const char *cl_szBestCryptCorporateEdition;
extern const char *cl_szBestCryptBaseEdition;
extern const char *cl_szShowExpirationWarning;

extern const char *cl_szName;
extern const char *cl_szCardHolderName;
extern const char *cl_szCardNumber;
extern const char *cl_szCardBillingAddress;
extern const char *cl_szCompany;
extern const char *cl_szAddress;
extern const char *cl_szCity;
extern const char *cl_szState;
extern const char *cl_szZipCode;
extern const char *cl_szPhone;
extern const char *cl_szEmail;
extern const char *cl_szResellerEmail;
extern const char *cl_szCountry;
extern const char *cl_szAdditionalInfo;
extern const char *cl_szLicenseType;
extern const char *cl_szNameFirst;
extern const char *cl_szNameLast;
extern const char *cl_szStreetAddress;

//
//	cl_VerifySignature
//		1. parses signed message
//		2. extracts license info
//		3. returns values
//			pkae_invalidSignature - if signature invalid,
//			pkae_invalidInputData - if message buffer does not contain label strings
//			pkae_ok	- if signature is valid.
//
int cl_VerifySignature(
		const char *messageBuff, int messageBuffSize,
		const BYTE *pk, int pkSize,
		const char **pLIPos = NULL, int *pLISize = NULL, // OUT position and size of license info 
												   // without singnature string and bounder strings
		UINT *pSN = NULL, UINT *pTQ = NULL,
		HPKA hPka_param = NULL
	);


//
//	cl_GetLicenseValue
//		Finds position and size of named value
//		returns values
//			pkae_invalidInputData - if message buffer does not contain label strings
//			pkae_ok	- if value was found
//
int cl_GetLicenseValue(
		const char **pValuePos, int *pValueSize,
		const char *messageBuff, int messageBuffSize, // whole message with Begin and End strings
		const char *valueName
	);

//
//	cl_GetLicenseValue
//		Extract integer data of named value
//		returns values
//			pkae_invalidInputData - if message buffer does not contain label strings
//			pkae_ok	- if value was found
//
int cl_GetLicenseValueInt(
		int *pValue,
		const char *messageBuff, int messageBuffSize, // whole message with Begin and End strings
		const char *valueName
	);

//
//	cl_CheckExpiredDemo
//		Extracts date of cl_szExpirationDate
//		returns values
//			pkae_invalidInputData - if message buffer does not contain 
//				the cl_szExpirationDate value, so the license is not demo version, 
//				and cannot be expired.
//			pkae_ok	- if value was found, so the licenss is demo version
//				*pValue will contains number of evaluation days
//
int cl_CheckExpiredDemo(
		__int64 *pValue,
		const char *messageBuff, int messageBuffSize // whole message with Begin and End strings
	);

//
//	cl_GetLicenseTime
//		Extracts date of szTimeField.
//			The value may be one of them cl_szExpirationDate or cl_szDate. 
//			Both the values are filled as Fri Apr 29 12:25:12 1994 (12345678)
//			Really it extracts last (12345678) as (time_t).
//		returns values
//			pkae_invalidInputData - if message buffer does not contain 
//				the szTimeField value.
//			ppe_invalidBlock - if value was found but was not properly scanned.
//			pkae_ok	- if value was found and properly parsed.
//
int cl_GetLicenseTime(
		time_t *pTime,
		const char *messageBuff, int messageBuffSize, // whole message with Begin and End strings
		const char *szTimeField = cl_szExpirationDate
	);


//
//	cl_ExtractDemoBody
//		Extracts content between the szBeginMSG and cl_szExpirationDate.
//		if properly extracted returns  pkae_ok.
//		Note, it does not check license validity, so we can use any unsigned patern
//
int cl_ExtractDemoBody( 
		const char **pBody, int *pBodySize,
		const char *templateBuff, int templateBuffSize );

//
//	cl_ExtractSignedLicense
//		Finds position of szBeginMSG string in buffer
//		Gets size upto end of szEndMSG
//		if successful returns pkae_ok;
//
int cl_ExtractSignedLicense(
		const char **pos, int *size,
		const char *buff, int buffSize );

//
//	cl_GetDateString
//		Finds position of Date: string in user license.
//		Returns true if the string was found.
//
bool cl_GetDateString(
		const char *liPos,  // license info position
		int liSize,			// license info size
		const char **pDataStringPos,
		int	*pDataStringSize
		);
//
//	cl_GetYearsQ
//		Returns value specified by cl_szNumberOfYears if the string is found
//		otherwise returns 1.
//
int cl_GetYearsQ(
		const char *liPos,  // license info position
		int liSize			// license info size
	);

//
//	cl_GetCodePage
//		New version of key generator writes the code page it uses for wchar to multibyte encoding
//
int cl_GetCodePage(
		const char *liPos,  // license info position
		int liSize			// license info size
	);

//
//	cl_getDaysLeft
//		1. Extracts license generation date and adds yearsQ to get license finish date.
//		2. Substract current date from the finish date to get days left.
//		Returns the days left if it is positive, otherwise returns zero.
//
int cl_getDaysLeft( const char *datePos, int dateSize, int yearsQ = 1 );

//
// cl_makeInteligentDigest, see implementation notes in LicenseGen->versionInfo.txt -> v. 1.07 ( 30-04-2002 )
//	if skipSpaceSymbols is true, 
//	 so all symbols 09 0a 0d 20 -> ( tab cr nl ' ' ) are skipped during digest accumulation.
//	Otherwise
//	 Extrates every strings without any '\n' and '\r' and adds both "\r\n", it allows to read old licenses.
//
int cl_makeInteligentDigest( const BYTE *buff, int size, BYTE *digest, bool skipSpaceSymbols = false );

class cPlainTextBlock;
bool cl_createArmoredBlock( cPlainTextBlock *ptb, const BYTE *buff, int buffSize, const char *szStart, const char *szEnd );

//
//	cl_readArmoredBlock
//		1. Extracts the body is concluded by szStart and szEnd strings
//		2. Decodes base64 bode to ptb->buffer.
//
bool cl_readArmoredBlock( cPlainTextBlock *ptb, const char *text, int textSize, const char *szStart, const char *szEnd );
int cl_readArmoredBlock( BYTE *bf, int *bfSize, const char *text, int textSize, const char *szStart, const char *szEnd );

bool cl_checkBase64Encoding(
		const BYTE *encBlock, 	int encBlockSize,
		const BYTE *decBlock,	int decBlockSize,
		const char *szBlockStart,
		const char *szBlockEnd
	);
	
int cl_getFingerprint(
	wchar_t *bfOut,		// wide character buffer with prepared fingerprint
	int *pBfOutSize,	// the count of wide characters
	const BYTE *bfIn,	// byte buffer with text
	int bfInSize
   );

//
//	cl_verifyCertificate
//		Verifies certificate by assigned public key, 
//		if pka is NULL it uses Jetico Public Key as default.
//		if validityTime it uses current time for certificate validation.
//
int cl_verifyCertificate( const BYTE *crtBuff, int crtSize, HPKA pka = NULL, time_t validityTime = 0 );

//
//	cl_getDescription
//		1. Extracts license from armored block
//		2. Writes recognised values in human readable form.
//
int cl_getDescription( cPlainTextBlock *ptb, BYTE *bfLicence, int bfSize, int *pCP, const char *szPrefix = NULL );

#endif /* _checkLicense_ */
