#include "cZLIBAlg.h"
#include "ZLIB/zlib.h"

int cCompressZLIB::compress( BYTE *bfOut, int *pBfOutSize, const BYTE *bfIn, int bfInSize )
{
	int res = ::compress( bfOut, (uLongf *)pBfOutSize, bfIn, (uLongf)bfInSize );

	switch( res )
	{
		case Z_OK		 : res = cae_ok; break;

		case Z_MEM_ERROR :
				assert( false );
				res = cae_memoryAllocation;
				break;

		case Z_BUF_ERROR :		res = cae_bufferTooSmall;    break;
		case Z_DATA_ERROR:		res = cae_inputDataIsCorrupted;		break;
		case Z_STREAM_ERROR:	res = cae_inputDataIsCorrupted;		break;
		default:				res = cae_undefined;

		assert( res == cae_ok );
	}

	return res;
}

int cCompressZLIB::uncompress( BYTE *bfOut, int *pBfOutSize, const BYTE *bfIn, int bfInSize )
{
	if ( pBfOutSize == 0 )
		return cae_inputDataIsCorrupted;

	uLongf outSize = (uLongf)*pBfOutSize;

	int res = ::uncompress( bfOut, &outSize, bfIn, bfInSize );

	switch( res )
	{
		case Z_OK		 : res = cae_ok; break;

		case Z_MEM_ERROR :
				assert( false );
				res = cae_memoryAllocation;
				break;

		case Z_BUF_ERROR : res = cae_bufferTooSmall;    break;
		case Z_DATA_ERROR: res = cae_inputDataIsCorrupted;		break;
		default:		   res = cae_undefined;

		assert( res == cae_ok );
	}

	*pBfOutSize = outSize;

	return res;
}
