#ifndef _cZLIBAlg_H_
#define _cZLIBAlg_H_

#include "cCompressAlg.h"

class cCompressZLIB: public cCompressAlg
{
public:
	static cCompressAlg * createAlg()
	{
		return new cCompressZLIB;
	}

	//
	//	Upon entry, destLen is the total size of the
	//	destination buffer, which must be at least 0.1% larger than sourceLen plus
	//	12 bytes. Upon exit, destLen is the actual size of the compressed buffer.
	//
	static unsigned int getMaxCompressedSize( unsigned int size )
	{
		return ( size * 1001 ) / 1000 + 12;
	}
	
	cCompressZLIB()
	{
	}

	~cCompressZLIB()
	{
	}

	int compress( BYTE *bfOut, int *pBfOutSize, const BYTE *bfIn, int bfInSize );
	int uncompress( BYTE *bfOut, int *pBfOutSize, const BYTE *bfIn, int bfInSize );
};

#endif /*_cZLIBAlg_H_ */
