#ifndef _compressAlg_H_
#define _compressAlg_H_

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#include "../crtLibErrs.h"
#include "cCompressAlg.h"

typedef class cCompressAlg * HCA; // Handle to comression algorithm

//
// Compression algorithm identifiers.
//

enum {
	caID_ZIP = 1,
	caID_ZLIB = 2,
	caID_BZip2 = 3,

	caID_last = caID_BZip2
};


const char *GetCompressAlgName( BYTE algID );

int ca_getIDsOfAvailableAlgAlgorithms( int *pIDsCount, int **ppIDsTab );
const char *ca_getCompressAlgName( BYTE algID );

int ca_createAlgorithm( HCA * pHCA, int algID );
void ca_free( HCA hCA );

//
//	ca_getMaxCompressedSize
//		call this function and allocates required size before ca_compress,
//		ca_compress ( in *bfOut ) will return real size busied by compressed data.
//
unsigned int ca_getMaxCompressedSize( int algID, unsigned int originalSize );
int ca_compress( HCA hCA, BYTE *bfOut, int *pBfOutSize, const BYTE *bfIn, int bfInSize );
int ca_uncompress( HCA hCA, BYTE *bfOut, int *pBfOutSize, const BYTE *bfIn, int bfInSize );

int ca_compress( BYTE algID, BYTE *bfOut, int *pBfOutSize, const BYTE *bfIn, int bfInSize );
int ca_uncompress( BYTE algID, BYTE *bfOut, int *pBfOutSize, const BYTE *bfIn, int bfInSize );

#endif /* _compressAlg_H_ */
