/*
 *  Copyright 2013 Jetico, Inc. All rights reserved.
 */

#pragma once

#if !(defined(_BIG_ENDIAN_DEFINED) || defined(_LITTLE_ENDIAN_DEFINED))

	#if defined (__BYTE_ORDER__)
		#if (__ORDER_BIG_ENDIAN__==__BYTE_ORDER__)
			#define	_BIG_ENDIAN_DEFINED
		#elif (__ORDER_LITTLE_ENDIAN__==__BYTE_ORDER__)
			#define	_LITTLE_ENDIAN_DEFINED
		#elif (__ORDER_PDP_ENDIAN__==__BYTE_ORDER__)
			#define	_PDP_ENDIAN_DEFINED
			#error "pdp endian"
		#else
			#error "machine is undefined endian"
		#endif

	#else

		#define LITTLE_ENDIAN_ORDER	0x41424344UL
		#define BIG_ENDIAN_ORDER	0x44434241UL
		#define PDP_ENDIAN_ORDER	0x42414443UL
		#define ENDIAN_ORDER		('ABCD')

		#if ENDIAN_ORDER==LITTLE_ENDIAN_ORDER
			#define	_LITTLE_ENDIAN_DEFINED
		#elif ENDIAN_ORDER==BIG_ENDIAN_ORDER
			#define	_BIG_ENDIAN_DEFINED
		#elif ENDIAN_ORDER==PDP_ENDIAN_ORDER
			#define _PDP_ENDIAN_DEFINED
		#else
			#error "machine is undefined endian"
		#endif

	#endif

#endif // !(defined(_BIG_ENDIAN_DEFINED) || defined(_LITTLE_ENDIAN_DEFINED))
