/*******************************************************************
 *
 *	Copyright (c) 1994-2000 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: sha1.h
 *	Description: declaration of SHA-1 Secure Hash Algorithm 
 *		external procedures
 *
 *******************************************************************/

/*
 *	SHA1 message-digest algorithm.
 */

#ifndef __SHA1_H__
#define __SHA1_H__

#define SHA1_DIGEST_SIZE  20

typedef unsigned char byte;

#include <stddef.h>

enum {
	SHA1_ERROR_NO = 0x0,
	SHA1_ERROR_INTERNAL_ERROR = 0x1
};

int SHA1Init( void *context );
int SHA1Process( void *context, const byte *data, size_t length );
int SHA1Final( void *context, byte *digest );
int SHA1Allocate( void **context);
int SHA1Free( void **context );

int SHA1MakeDigest( const byte *message, int messageLength, byte *digest );
int SHA1RandomGenerate( byte *byteBuffer, size_t byteBufferSize, byte *seedBuffer, size_t seedBufferSize );
int SHA1RandomGenerateKey(
                          byte *byteBuffer ,
                          size_t byteBufferSize ,
                          byte *seedBuffer ,
                          size_t seedBufferSize );

#endif /* __SHA1_H__ */
