/*******************************************************************
 *
 *	Copyright (c) 1994-2005 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: sha256.h
 *	Revision: 
 *	Created:
 *	Description: declaration of SHA-256 (SHA-2) Secure Hash Algorithm 
 *		external procedures
 *
 *******************************************************************/

/*
 *	SHA-256 message-digest algorithm.
 */

#ifndef __SHA256_H__
#define __SHA256_H__

#define SHA256_DIGEST_SIZE  32

#define SHA256_ERROR_NO				0x0
#define SHA256_ERROR_INTERNAL_ERROR	0x1

typedef unsigned char byte;

int SHA256_Init(void *context );

int SHA256_Process(void   *context, 
                const byte   *data, 
                size_t length);

int SHA256_Update(void *context, byte *data);

int SHA256_Final(void *context, 
              byte *digest);

int SHA256_Allocate(void **context);

int SHA256_Free(void **context);

int SHA256_MakeDigest( byte *message, int messageLength, byte *digest );

int SHA256_RandomGenerate(byte *byteBuffer, size_t byteBufferSize, byte *seedBuffer, size_t seedBufferSize );

#endif /* __SHA256_H__ */
