#include "intsize.h"

const bc_u64 r[5][5]={ {0,36,3,41,18},
			{1,44,10,45,2},
			{62,6,43,15,61},
			{28,55,25,21,56},
			{27,20,39,8,14}
};

int mod (int a, int b)
{
  if(b < 0) //you can check for b == 0 separately and do what you want
    return mod(-a, -b);
  int ret = a % b;
  if(ret < 0)
    ret+=b;
  return ret;
}

void sha3_round( bc_u64 A[5][5], bc_u64 RC){
  bc_u64 C[5];
  bc_u64 D[5];
  bc_u64 B[5][5];

  /* Theta step */
  for(bc_u8 x=0;x<5;x++){
    C[x]=A[x][0] ^ A[x][1] ^ A[x][2]^ A[x][3] ^ A[x][4];
  }
  for(bc_u8 x=0;x<5;x++){
    D[x]=C[(x + 4) % 5] ^ ((C[(x + 1) % 5] << 1) | (C[(x + 1) % 5] >> 63));
  }
  for(bc_u8 x=0;x<5;x++){
    for(bc_u8 y=0;y<5;y++){
      A[x][y]=A[x][y]^D[x];
    }
  }

  /*Rho and pi steps*/
  for(bc_u8 x=0;x<5;x++){
    for(bc_u8 y=0;y<5;y++){
      B[y][mod((2*x+3*y),5)]=((A[x][y] << r[x][y]) | (A[x][y] >> (64-r[x][y])));
    }
  }

  /*Xi state*/
  for(bc_u8 x=0;x<5;x++){
    for(bc_u8 y=0;y<5;y++){
      A[x][y]=B[x][y]^((~B[mod((x+1),5)][y]) & B[mod((x+2),5)][y]);
    }
  }

  /*Last step*/
  A[0][0]=A[0][0]^RC;
}
  
