/*******************************************************************
 *
 *	Copyright (c) 2014 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: sha3-512.h
 *	Revision: 
 *	Created:
 *	Description: declaration of SHA3_512 (Keccak) Secure Hash Algorithm 
 *	             external procedures
 *
 *******************************************************************/

/*
 *	SHA3(keccak) 512 bit message-digest algorithm.
 */

#ifndef __SHA3_512_H__
#define __SHA3_512_H__

#include "./intsize.h"

#define SHA3_512_DIGEST_SIZE  64

#define SHA3_512_ERROR_NO               0x0
#define SHA3_512_ERROR_INTERNAL_ERROR   0x1

int SHA3_512_AutoTest();

int SHA3_512_Init(void *ctx);

int SHA3_512_Process(void *ctx, const unsigned char *data, bc_u32 length);

int SHA3_512_Update(void *ctx, unsigned char *data);

int SHA3_512_Final(void *ctx, unsigned char *digest); /* 'digest' array must be >= 32 bytes */

int SHA3_512_Allocate(void **ctx);

int SHA3_512_Free(void **ctx);

int SHA3_512_MakeDigest( const unsigned char *message, bc_u32 messageLength, unsigned char *digest );

#endif /* __SHA3_512_H__ */
