/**
 * Copyright 2012 Jetico Inc. Oy.
 * All rights reserved.
 *
 * INTSIZE.H - Types' definitions.
 * 
 */

#ifndef __INTSIZE
#define __INTSIZE


#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef WORD
typedef unsigned short WORD;
#endif

#ifndef BOOL
typedef int BOOL;
#endif


#ifdef _WIN32

/* Definitions for Windows */

#ifndef DWORD
typedef unsigned long DWORD;
#endif

#ifndef LONGLONG
typedef __int64 LONGLONG;
#endif

#ifndef ULONGLONG
typedef unsigned __int64 ULONGLONG;
#endif


#elif defined( RECOVERY16 ) || defined( CODE_16_BIT )

/* Definitions for 16-bit DOS */

#ifndef RECOVERY16_TYPES
#define RECOVERY16_TYPES

#ifndef UCHAR
typedef unsigned char UCHAR;
#endif

#ifndef DWORD
typedef unsigned long DWORD;
#endif

#ifndef WCHAR
typedef unsigned short WCHAR;
#endif

#ifndef LARGE_INTEGER
typedef struct
{
	unsigned long d0;	
	long          d1;	
} LARGE_INTEGER;
#endif

#ifndef ULONGLONG
typedef struct
{
	unsigned long d0;	
	unsigned long d1;	
} ULONGLONG;
#endif


#ifndef LONGLONG
typedef struct
{
	unsigned long d0;	
	long          d1;	
} LONGLONG;
#endif

#endif // RECOVERY16_TYPES

#else

/* Definitions for not-Windows OS */
#include <stdint.h>

#ifndef DWORD
typedef uint32_t DWORD;
#endif

#ifndef LONGLONG
typedef int64_t LONGLONG;
#endif

#ifndef ULONGLONG
typedef uint64_t ULONGLONG;
#endif

#ifndef WCHAR
typedef unsigned short WCHAR;
#endif

#endif //_WIN32


#endif //__INTSIZE
