/*******************************************************************
 *
 *	Copyright (c) 2014 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: Whirlpool-512.h
 *	Revision: 
 *	Created:
 *	Description: declaration of Whirlpool_512 Secure Hash Algorithm 
 *	             external procedures
 *
 *******************************************************************/

/*
 *	Whirlpool 512 bit message-digest algorithm.
 */

#ifndef __Whirlpool512_H__
#define __Whirlpool512_H__

#define Whirlpool512_DIGEST_SIZE  64

#define Whirlpool512_ERROR_NO               0x0
#define Whirlpool512_ERROR_INTERNAL_ERROR   0x1

int Whirlpool512_AutoTest();

int Whirlpool512_Init(void *ctx);

int Whirlpool512_Process(void *ctx, const unsigned char *data, unsigned int length);

int Whirlpool512_Update(void *ctx, unsigned char *data);

int Whirlpool512_Final(void *ctx, unsigned char *digest); /* 'digest' array must be >= 32 bytes */

int Whirlpool512_Allocate(void **ctx);

int Whirlpool512_Free(void **ctx);

int Whirlpool512_MakeDigest( const unsigned char *message, unsigned int  messageLength, unsigned char *digest );

#endif /* __Whirlpool512_H__ */
