#ifndef __cHashAlg__
#define __cHashAlg__

#include "../crtLibErrs.h"
#include "../publicKeyAlgs/Power/Windefs.h"
#include <assert.h>

class cHashAlg
{
public:
	static cHashAlg * createAlg();
#ifdef _WIN32
#pragma warning( disable : 4100 )
#endif
	virtual int getDigestSize() 						{ return hae_internalError; }
	virtual int Process( const BYTE *data, int length )	{ return hae_internalError; }
	virtual int Final  ( BYTE *digest )					{ return hae_internalError; }
	virtual int Init   ()								{ return hae_internalError; }
	virtual ~cHashAlg()									{ return; }
#ifdef _WIN32
#pragma warning( default : 4100 )
#endif
	int makeDigest(
		BYTE *digest,	// Output digest buffer.
						// Note, size of the buffer has not to be less then size
						// the ha_getDigestSize returns.
		BYTE *message,	// Input message buffer. 
		int messageSize	// Size of message buffer.
	)
	{
		int res;
		
		res = Init();
		if ( res != hae_ok ) return res;

		res = Process( message, messageSize );
		
		if ( res != hae_ok ) return res;

		return Final( digest );
	}
};

#endif // __cHashAlg__
