#pragma once

#include "SHA3-512/sha3-512.h"

class cHashSHA3_512: public cHashAlg
{
	void *context;

public:
	static cHashAlg * createAlg()
	{
		return new cHashSHA3_512;
	}
	
	cHashSHA3_512()
	{
		SHA3_512_Allocate( &context );
		SHA3_512_Init( context );
	}

	~cHashSHA3_512()
	{
		SHA3_512_Free( &context );
	}

	int Init	( )								{ return SHA3_512_Init( context ); }
	int Process	( const BYTE *data, int length ){ return SHA3_512_Process( context, data, length); }
	int Final	( BYTE *digest )				{ return SHA3_512_Final( context, digest); }
	int getDigestSize()							{ return SHA3_512_DIGEST_SIZE; }
};
