#ifndef _cHashRipemd_H_
#define _cHashRipemd_H_

#include "ripemd/ripemd.h"

class cHashRipemd: public cHashAlg
{
	void *context;

public:
	static cHashAlg * createAlg()
	{
		return new cHashRipemd;
	}
	
	cHashRipemd()
	{
		RipemdAllocate( &context );
		RipemdInit( context );
	}

	~cHashRipemd()
	{
		RipemdFree( &context );
	}

	int Init	( )								{ return RipemdInit( context ); }
	int Process	( const BYTE *data, int length ){ return RipemdProcess( context, data, length); }
	int Final	( BYTE *digest )				{ return RipemdFinal( context, digest); }
	int getDigestSize() 						{ return RIPEMD_DIGEST_SIZE_BYTES; }
};

#endif /* _cHashRipemd_H_ */ 
