#ifndef _cHashSHA1_H_
#define _cHashSHA1_H_

#include "SHA1/Sha1.h"

class cHashSHA1: public cHashAlg
{
	void *context;

public:
	static cHashAlg * createAlg()
	{
		return new cHashSHA1;
	}
	
	cHashSHA1()
	{
		SHA1Allocate( &context );
		SHA1Init( context );
	}

	~cHashSHA1()
	{
		SHA1Free( &context );
	}

	int Init	( )								{ return SHA1Init( context ); }
	int Process	( const BYTE *data, int length ){ return SHA1Process( context, data, length); }
	int Final	( BYTE *digest )				{ return SHA1Final( context, digest); }
	int getDigestSize()							{ return SHA1_DIGEST_SIZE; }
};

#endif /* _cHashSHA1_H_ */
