#ifndef _cHashSHA256_H_
#define _cHashSHA256_H_

#include "SHA256/sha256.h"

class cHashSHA256: public cHashAlg
{
	void *context;

public:
	static cHashAlg * createAlg()
	{
		return new cHashSHA256;
	}
	
	cHashSHA256()
	{
		SHA256_Allocate( &context );
		SHA256_Init( context );
	}

	~cHashSHA256()
	{
		SHA256_Free( &context );
	}

	int Init	( )								{ return SHA256_Init( context ); }
	int Process	( const BYTE *data, int length ){ return SHA256_Process( context, data, length); }
	int Final	( BYTE *digest )				{ return SHA256_Final( context, digest); }
	int getDigestSize()							{ return SHA256_DIGEST_SIZE; }
};

#endif /* _cHashSHA256_H_ */
