#pragma once

#include "SHA512/sha512.h"

class cHashSHA512: public cHashAlg
{
	void *context;

public:
	static cHashAlg * createAlg()
	{
		return new cHashSHA512;
	}
	
	cHashSHA512()
	{
		SHA512_Allocate( &context );
		SHA512_Init( context );
	}

	~cHashSHA512()
	{
		SHA512_Free( &context );
	}

	int Init	( )								{ return SHA512_Init( context ); }
	int Process	( const BYTE *data, int length ){ return SHA512_Process( context, data, length); }
	int Final	( BYTE *digest )				{ return SHA512_Final( context, digest); }
	int getDigestSize()							{ return SHA512_DIGEST_SIZE; }
};
