/*****************************************************************\
*
*  Copyright (c) 2015 Jetico, Inc., Finland 
*  All rights reserved.
*
*  File: cHashSkein512.h
*  Revision:
*  Created: 25.02.2015
*  Description: Hash Skein with 512 bits.
*
\*****************************************************************/

#pragma once

#include "Skein512/skein512.h"

class cHashSkein512: public cHashAlg
{
	void *context;

public:
	static cHashAlg * createAlg()
	{
#ifdef _DEBUG
		if ( Skein512_AutoTest() != 0 )
			return NULL;
#endif
		return new cHashSkein512;
	}
	
	cHashSkein512()
	{
		Skein512_Allocate( &context );
		Skein512_Init( context );
	}

	~cHashSkein512()
	{
		Skein512_Free( &context );
	}

	int Init	( )								{ return Skein512_Init( context ); }
	int Process	( const BYTE *data, int length ){ return Skein512_Process( context, data, length); }
	int Final	( BYTE *digest )				{ return Skein512_Final( context, digest); }
	int getDigestSize()							{ return Skein512_DIGEST_SIZE; }
};
