#pragma once

#include "Whirlpool512/Whirlpool512.h"

class cHashWhirlpool512: public cHashAlg
{
	void *context;

public:
	static cHashAlg * createAlg()
	{
		return new cHashWhirlpool512;
	}
	
	cHashWhirlpool512()
	{
		Whirlpool512_Allocate( &context );
		Whirlpool512_Init( context );
	}

	~cHashWhirlpool512()
	{
		Whirlpool512_Free( &context );
	}

	int Init	( )								{ return Whirlpool512_Init( context ); }
	int Process	( const BYTE *data, int length ){ return Whirlpool512_Process( context, data, length); }
	int Final	( BYTE *digest )				{ return Whirlpool512_Final( context, digest); }
	int getDigestSize()							{ return Whirlpool512_DIGEST_SIZE; }
};
