/*
	Copyright (c) 1997, 1998 Data Fellows Ltd., Espoo, Finland
	All rights reserved.

	File: ripemd.h
	Revision: $Revision
	Created:
	Description: RIPE-MD message-digest algorithm.
*/

#ifndef __RIPEMD_H__
#define __RIPEMD_H__

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#define RIPEMD_DIGEST_SIZE_BYTES   20

enum { RIPEMD_OK = 0, RIPEMD_MALLOC_ERROR };

int RipemdInit		( void *self );
int RipemdProcess	( void *self, const BYTE *data, int length );
int RipemdUpdate	( void *self, const BYTE *data );
int RipemdFinal		( void *self, BYTE *digest );
int RipemdAllocate	( void **pAlgorithm );
int RipemdFree		( void **pAlgorithm );

#endif /* __RIPEMD_H__ */
