#ifndef __WinDefs__
#define __WinDefs__

// #define _UseAsm_

#ifdef _WIN32
#include <windows.h>
#else

#include <stdint.h>
#include <time.h>

typedef int64_t			__int64;
typedef int64_t			LONGLONG;
typedef uint64_t		ULONGLONG;
typedef int32_t 		LONG;
typedef uint64_t		DWORDLONG;
typedef uint32_t		DWORD;
typedef uint32_t		UINT;
typedef uint32_t		*PUINT;
typedef uint16_t	  	WORD;
typedef uint16_t	  	USHORT;
typedef uint16_t	  	*PUSHORT;
typedef uint8_t			BYTE;
typedef uint8_t			UCHAR;
typedef uint8_t			*PUCHAR;
//typedef unsigned char		byte;
typedef int32_t			BOOL;
//typedef unsigned short 		wchar_t;

/*
typedef long long		__int64;
typedef long long		LONGLONG;
typedef unsigned long long	ULONGLONG;
typedef long 			LONG;
typedef unsigned long long	DWORDLONG;
typedef unsigned long		DWORD;
typedef unsigned int		UINT;
typedef unsigned short  	WORD;
typedef unsigned char		BYTE;
//typedef unsigned char		byte;
typedef int			BOOL;
//typedef unsigned short 		wchar_t;
*/

#define TRUE ( 1 == 1 )
#define FALSE ( !TRUE )
#define CP_ACP 0

#ifndef _WINDEF_
#define LOWORD(l)		((WORD)(l))
#define HIWORD(l)		((WORD)(((UINT)(l) >> 16) & 0xFFFF))
#define LOBYTE(w)		((BYTE)(w))
#define HIBYTE(w)		((BYTE)(((WORD)(w) >> 8) & 0xFF))
#ifndef NULL
#define NULL 0
#endif
#define MAKEWORD(a, b)	((WORD)(((BYTE)((UINT)(a) & 0xff)) | ((WORD)((BYTE)((UINT)(b) & 0xff))) << 8))

#pragma pack(push, 1)

typedef struct _SYSTEMTIME {
    WORD wYear;
    WORD wMonth;
    WORD wDayOfWeek;
    WORD wDay;
    WORD wHour;
    WORD wMinute;
    WORD wSecond;
    WORD wMilliseconds;
} SYSTEMTIME;

typedef struct _FILETIME {
	DWORD dwLowDateTime;
	 DWORD dwHighDateTime;
} FILETIME, *PFILETIME, *LPFILETIME;

typedef union _LARGE_INTEGER {
	struct {
		UINT LowPart;
		LONG HighPart;
	};
	struct {
		UINT LowPart;
		LONG HighPart;
	} u;
	LONGLONG QuadPart;
} LARGE_INTEGER, *PLARGE_INTEGER;

#pragma pack(pop)

#endif // _WINDEF_

#endif // WIN32

#ifdef __BIG_ENDIAN
#define bleLoPos 1
#define bleHiPos 0
#else
#define bleLoPos 0
#define bleHiPos 1
#endif

#pragma pack(push, 1)

typedef union _UL_INTEGER {
        DWORDLONG QuadPart;
        UINT Uint[2];
} UL_INTEGER, *PUL_INTEGER;

#pragma pack(pop)


#define LOUINT(__X)    ((UINT)((ULONGLONG)(__X) & 0xFFFFffff))

#define DWLo( pX ) ((PUL_INTEGER(pX))->Uint[bleLoPos] )
#define DWHi( pX ) ((PUL_INTEGER(pX))->Uint[bleHiPos] )

#ifdef __avoid32biShiftError //_WIN32

//
//	MSVC Optimization is failed with shift ULONGLONG on 32 bit
//
#define _useHIUINTProc

UINT HIUINT( ULONGLONG X );

#else

#define HIUINT(__X)  ((UINT)((ULONGLONG)(__X) >> 32))

#endif // _WIN32

#define _HIUINT( X ) DWHi(&X)


#endif // __WinDefs__

