#ifndef __BC_GOST
#define __BC_GOST

#include "../ALG_DEF.H"

#define SERVICE_NAME	"BC_Gost"
#define DISPLAY_NAME    "GOST"
#define ALGORITHM_ID     0xaa

// Key length in bites
#define KEY_LENGTH          (256)
#define KEY_LENGTH_EXTENDED (1024)

#define DRIVER_MAJOR_VERSION	1
#define DRIVER_MINOR_VERSION	1


BOOL
GOST_KeyExtend( PUCHAR KeySource,          // 8  32-bit words
           PUINT KeyDestination );   // 32 32-bit words


VOID
GOST_Encrypt( UINT *IVector, 
         UINT *KeyAdress,
         UINT *SrcBuffer,
         UINT *DstBuffer,
         UINT Length );    // in bytes

VOID
GOST_Decrypt( UINT *IVector, 
         UINT *KeyAdress,
         UINT *SrcBuffer,
         UINT *DstBuffer,
         UINT Length );    // in bytes

//
//	Encrypts/decrypts two uints in ECB mode.
//

#define BLOCK_SIZE ( 2 * sizeof( UINT ) )

VOID
GOST_ECB_Encrypt(
		PUINT N1,
		PUINT N2,
		PUINT KeyAddress );

VOID
GOST_ECB_Decrypt(
		PUINT N1,
		PUINT N2,
		PUINT KeyAddress );

#endif
