#ifndef __BC_DES
#define __BC_DES

#include "../ALG_DEF.H"

#define DES_ECB_ENCRYPT 0
#define DES_ECB_DECRYPT 1

/******* Exported functions *********/

#define KEY_LENGTH_DES          (64)
#define KEY_LENGTH_EXTENDED_DES (128*8)

#define BLOCK_SIZE 8

BOOL
DES_KeyExtend( BYTE  *KeySource,          // 8       8-bit  uchars
               UINT *KeyDestination );   // (128/4) 32-bit words


//
// Declaration of DES in ECB mode, necessary to:
// 1) test the DES implementation;
// 2) create Tripple DES implementation.
//

void DES_ECB_mode( const BYTE  *Input,       /* 8 bytes of input data              */
                   BYTE  *Output,      /* 8 bytes of output data             */
                   UINT *KeySchedule, /* [16][2] array of UINTs            */ 
                   BYTE  Operation);    /* DES_ECB_ENCRYPT or DES_ECB_DECRYPT */


#endif
