/////////////////////////////////////////////////////////////////
//
//      Copyright (c) 1994-2008 Jetico, Inc., Finland
//      All rights reserved.
//
//      File: cAlgDummy.h
//      Revision:
//      Created:
//      Description:
//
/////////////////////////////////////////////////////////////////

#ifndef __cAlgDummy__
#define __cAlgDummy__

class cAlgDummy : public cSymAlg
{
 public:
#ifdef _WIN32
#pragma warning( disable : 4100 )
#endif
	static cSymAlg *createAlg( BYTE *key, int keySize )	{ return new cAlgDummy;	}
	static int getKeySize( int *pMax = NULL )		{ return 0; }
	static int getBlockSize()				{ return 0; }
	static const char *getDisplayName()			{ return "Dummy"; }
#ifdef _WIN32
#pragma warning( default : 4100 )
#endif
	~cAlgDummy() {};

	virtual int encryptECB(
		const BYTE *inBf,	// Input plaintext buffer. 
		BYTE *outBf,		// Output encrypted buffer
		int bfSize		// In/out buffers' size.
		)
	{
		memcpy( outBf, inBf, bfSize );
		return sae_ok;
	}

	virtual int decryptECB(
		const BYTE *inBf,	// Input encrypted buffer.
		BYTE *outBf,		// Output plaintext buffer.
		int bfSize		// In/out buffers' size.
		)
	{
		return encryptECB( inBf, outBf, bfSize );
	}

	virtual BOOL getAlgConstants( int *blockSize, int *keySize )
	{
		*blockSize = getBlockSize();
		*keySize = getKeySize();
		return true;
	}
};

#endif // __cAlgDummy__
