/////////////////////////////////////////////////////////////////
//
//      Copyright (c) 1994-2008 Jetico, Inc., Finland
//      All rights reserved.
//
//      File: cAlgGOST.h
//      Revision:
//      Created:
//      Description:
//
/////////////////////////////////////////////////////////////////

#ifndef __cAlgGOST__
#define __cAlgGOST__

#include "ALG_DEF.H"
#include "cSymAlg.h"

class cAlgGOST: public cSymAlg
{
 private:
	BYTE *m_extKey;
	int  m_keySize;

	BOOL getAlgConstants( int *blockSize, int *keySize );

 public:

     cAlgGOST();
	 ~cAlgGOST();

	static int getBlockSize();
	static const char *getDisplayName();

	// returns minimum key size in bytes, 
	// if algorithm supports other key length, pMax contains maximum key size
	// if algorithm supports fixed key length, pMax is equal to returned value
	static int getKeySize( int *pMax = NULL );

	static cSymAlg *createAlg( BYTE *key, int keySize );  // keySize in bytes

	// Encryption and decription in Electronic Code Book mode

	virtual int encryptECB(
		const BYTE *inBf,		// Input plaintext buffer. 
		BYTE *outBf,	// Output encrypted buffer
		int  bfSize		// In/out buffers' size.
		);

	virtual int decryptECB(
		const BYTE *inBf,		// Input encrypted buffer.
		BYTE *outBf,	// Output plaintext buffer.
		int  bfSize		// In/out buffers' size.
		);
};

#endif // __cAlgGOST__

