#ifndef __objectIdentifiers__
#define __objectIdentifiers__

//
//	TOID_N
//		Table for known Object IDentifier for 'Name' - ASN.1 type.
//

struct objUnit
{
	BYTE code;
	char *name;
	char *description;
};

struct tableUnit
{
	BYTE *code;
	int codeSize;
	char *name;
	char *description;
	objUnit *T;
	int Q;
};

extern tableUnit COID_T[];
extern const int COID_Q;

#define TSize( T ) ( sizeof( T ) / sizeof( *T ) )

//
//	Function: string2oid
//		Converts OID string to BYTE buffer.
//		Returns -1 if *pOidSize too small, otherwise return filled size.
//
int string2oid ( BYTE *oid, int *pOidSize, const char *str );

//
//	Function: oid2tring
//
//	converts a DER encoding ASN.1 object-identifier into dot-string format
// 
char *oid2string( char *str, BYTE *oidVal, DWORD oidSize );

//
//	Function: findOID
//		Tries to find an OID in Common oid table.
//		Returns -1 if specified OID was not found.
//
int findOID( int *pNum, int *pSubNum, BYTE *OID, int OIDSize );

//
//	Function: getOIDName
//		Extracts the oid name and name of main table. 
//
char *getOIDName( char **pName, char **pSubName, int tabN, int subTabN );

#endif // __objectIdentifiers__