#ifndef __base64funcs__
#define __base64funcs__

#include "../crtLibErrs.h"

#include <windows.h>

//
//	Uses RFC 1991 - ASCII Armor 
//

int findEncodedBlock(
		const BYTE **pBlock,		// OUT - Pointer to byte position of encoded block
		int *pBlockSize,	// OUT - Pointer to finded size of encoded block
		const BYTE *pkt,			// IN - the packet with encoded block to be find.
		int pktSize,		// IN - the packet size
		const char *szBlockStart,
		const char *szBlockEnd,
		char **pArmorHeaders = NULL // OUT pointer to position of Armor headers
									// the headers are separated by single 0x0A symbol
									// and are terminated by double 0x0A symbols ( a blank line )
		);

int base64Decode(
		BYTE *decBlock,		// OUT - buffer for decoded data.
		int *pDecBlockSize,	// IN - pointer for decoded size, if size of 
							// the output block is too small return ppe_bufferTooSmall
							// OUT - required or really filled size 
		const BYTE *encBlock,		// IN - encoded buffer
		int encBlockSize );

int base64Encode(
		BYTE *encBlock,		// OUT - buffer for encoded data.
		int *pEncBlockSize,	// IN - pointer for encoded size, if size of 
							// the output block is too small return ppe_bufferTooSmall
							// OUT - required or really filled size 
		const BYTE *decBlock,		// IN - plain text buffer
		int decBlockSize,

		const char *szBlockStart = NULL,	// If the strings are not NULL,
		const char *szBlockEnd = NULL		// so the encoded block will be encapsulated by the strings
		);

#endif // __base64funcs__
