#include "x509_publicKey.h"
#include "x509_tags.h"
#include "x509_structs.h"
#include "pkcs12_funcs.h"
#include "ASN1_parseAndPrint.h"
#include "base64funcs.h"
#include "../SMemory/SBlocks.h"
#include "../PGPPkts/pktdefs.h"
#include "../hashAlgs/hashAlgs.h"
#include "../symmetricAlgs/symmetricAlgs.h"
#include "oidFuncs.h"






int x509_certParse( BYTE *ptr, int size )
{
//	const char *start = "-----BEGIN X509 CERTIFICATE-----";
//	const char *end   = "-----END X509 CERTIFICATE-----";

//	Z:\CertificateLib\Parser\Vit_Keys\x509sample1.txt
	const char *start = "-----BEGIN CERTIFICATE-----";
	const char *end   = "-----END CERTIFICATE-----";

	const BYTE *block;
	int blockSize;

	int res = findEncodedBlock( &block, &blockSize, ptr, size, start, end );

	if ( res != ppe_ok )
		return res;

	int decBlockSize = 0;

	res = base64Decode( NULL, &decBlockSize, block, blockSize );

	if ( res != ppe_bufferTooSmall )
		return res;


	BYTE *decBlock = new BYTE[ decBlockSize ];

	if ( decBlock == NULL )
		return 1;

	res = base64Decode( decBlock, &decBlockSize, block, blockSize );
	if ( res != ppe_ok )
		return res;

	x509_certificate crt;

	res = crt.parse( decBlock, decBlockSize );

	delete decBlock;

	return res;
}

#ifdef _DEBUG
static BYTE *start = 0;
int x509_test( BYTE *ptr, int size, bool skipOctetParsing )
{
	start = ptr;

	return ASN1_parseAndPrintUnit( ptr, size, skipOctetParsing );
//	return pwdTest();

//	return PFX_PDU_parse( ptr, size );

	return x509e_internalError;
}
#endif
