#ifndef ISAAC_H
#define ISAAC_H

#ifdef __cplusplus
extern "C" {
#endif

/**
  Initializes and returns ISAAC context with specified random seed.
*/
extern void *IsaacInit(const void *seed, unsigned seedLength);

/**
  Frees ISAAC context.
*/
extern void IsaacRelease(void *context_);

/**
  Generates specified amount of pseudo-random bytes using ISAAC algorythm.
*/
extern void IsaacGenerate(void *context_, void *buffer, unsigned bufferSize);

#ifdef __cplusplus
}
#endif
#endif
