/*
------------------------------------------------------------------------------
isaac64.h: definitions for a random number generator
Bob Jenkins, 1996, Public Domain
------------------------------------------------------------------------------
*/
#ifndef ISAAC_STANDARD
#include "standard.h"
#endif

#ifndef ISAAC64
#define ISAAC64

#define RANDSIZL   (8)
#define RANDSIZ    (1<<RANDSIZL)

typedef struct randctx64
{
  ub8 randcnt;
  ub8 randrsl[RANDSIZ];
  ub8 randmem[RANDSIZ];
  ub8 randa;
  ub8 randb;
  ub8 randc;
} randctx64;

/*
------------------------------------------------------------------------------
 If (flag==TRUE), then use the contents of randrsl[0..255] as the seed.
------------------------------------------------------------------------------
*/

#ifdef __cplusplus
extern "C" {
#endif
extern void randinit64(randctx64 *ctx, word flag);

extern void isaac64(randctx64 *ctx);

#ifdef __cplusplus
}
#endif

#endif
