/*
 * Copyright 2010 Jetico, Inc. All rights reserved.
 */

#ifndef BC_PASSWORD_H
#define BC_PASSWORD_H

#include <cstddef>
#include <string.h>


/// Password sizes in bytes.
enum {
	kBCPasswordMin	= 8,
    kBCPasswordMax	= 512
};

/**
 * Password buffer.
 * Automatically shred data on scope end.
 */
struct BCPassword {
    char buf[kBCPasswordMax];
    size_t length;

    BCPassword() {
        this->clear();
    }

    BCPassword(const BCPassword *p) {
        this->length = p->length;
        memcpy(this->buf, p->buf, sizeof(p->buf));
    }

    ~BCPassword() {
        this->clear();
    }

    void set(const char* pwd) {
        this->clear();
        strncpy(buf, pwd, sizeof(buf));
        length = strlen(buf);
    }

    void clear() {
        memset(buf, 0, sizeof(buf));
        length = 0;
    }
};


#endif

