/*
 *  Copyright 2011 Jetico, Inc. All rights reserved.
 *
 */

#ifndef LIBFS_EXFAT_H
#define LIBFS_EXFAT_H

#include "exfat_format.h"

struct fs_volume;
struct fs_extent;


/**
 * Internal fat volume superblock structure.
 */
typedef struct exfat_superblock {
	exfat_bootsect_t	bs;		// bootsector copy
} exfat_superblock_t;


/**
 * Accumulated directory entry info.
 * Describes a single file or directory entry.
 */
typedef struct exfat_dirent {
    struct exfat_entry_name         name;
    struct exfat_entry_file         file;
    struct exfat_entry_file_info    info;
} exfat_dirent_t;


extern int exfat_init_volume(struct fs_volume* vol);

#endif
