#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include <assert.h>
#include "hfsplus/hfsp.h"

int main(int argc, char **argv) 
{
    int		ret, frozen = 0;
    fs_volume_t	vol;
    fs_extent_t	*ext;

    memset(&vol, 0, sizeof(vol));

    if (2 < argc) {
	vol.offset = strtol(argv[2], NULL, 16);
    } else {
	vol.offset = 0;
    }
    
    vol.fd = open(argv[1], O_RDONLY);
    //    vol.fd = open(argv[1], O_RDWR);
    if (0 > vol.fd) {
	printf("Failed to open '%s': %s\n", argv[1], strerror(errno));
	return -1;
    }
    /*
    ret = fcntl(vol.fd, F_FREEZE_FS, NULL);
    if (ret) {
	frozen = 0;
	printf("Failed to freeze '%s': %s\n", argv[1], strerror(errno));
    } else {
	frozen = 1;
    }
    */
    printf("Source: %s, offset: 0x%llX\n", argv[1], vol.offset);

    ret = hfsp_init_volume(&vol);
    if (0 == ret) {
	if (1 && vol.get_free_space) {
	    ext = vol.get_free_space(&vol);
	    if (ext) {
		fs_print_extent_list(ext, 512);
		fs_put_extent_list(ext);
		ext = NULL;
	    }
	}
    }
    /*
    if (frozen) {
	ret = fcntl(vol.fd, F_THAW_FS, NULL);
	if (ret) {
	    printf("Failed to thaw '%s': %s\n", argv[1], strerror(errno));
	}
    }
    */
    fslib_close_volume(&vol);

    return 0;
}

