/*
 *  Created by Evgeny Yakovlev on 7/22/11.
 *  Copyright 2011 Jetico, Inc. All rights reserved.
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>

#include "fslib.h"

int main(int argc, char** argv) 
{
	if(argc < 2) {
		printf("Specify block device\n");
		return EXIT_FAILURE;
	}
	
	const char* blkdev = argv[1];
	
	fs_volume_t vol;
	memset(&vol, 0, sizeof(vol));
	int rc = fslib_open_volume(blkdev, O_RDONLY, &vol);
	if(0 != rc) {
		printf("Failed initializing volume\n");
		return EXIT_FAILURE;
	}
	
	
	if(vol.display) {
		printf("\nVolume info:\n");
		printf("------------\n");
		
		vol.display(&vol);
	}
	
	if(vol.get_free_space) {
		fs_extent_t* freespace = vol.get_free_space(&vol);
		if(!freespace) {
			printf("Failed mapping volume free space\n");
			return EXIT_FAILURE;
		}
		
		printf("\nVolume free space map (sectors):\n");
		printf("--------------------------------\n");
		fs_print_extent_list(freespace, 512);
		fs_put_extent_list(freespace);
	}
	
	fslib_close_volume(&vol);
	return EXIT_SUCCESS;
}