#ifndef BC_MEM_H
#define BC_MEM_H

//#define BC_DEBUG
#define BC_ALLOC_MAX 256

#ifdef BC_DEBUG
#include <linux/types.h>
extern void* alloc_wrapper(size_t size, int alloc_virtual);

extern void free_wrapper(void *mem, int alloc_virtual);

extern void print_unfree_memory(void);

#define KMALLOC(size) alloc_wrapper(size, 0)
#define KFREE(mem) free_wrapper(mem, 0);

#define VMALLOC(size) alloc_wrapper(size, 1)
#define VFREE(mem) free_wrapper(mem, 1)

#define PRINT_UNFREE_MEM() print_unfree_memory()

#else

#include <linux/vmalloc.h>

#define KMALLOC(size) kmalloc(size, GFP_KERNEL)
#define KFREE(mem) kfree(mem)

#define VMALLOC(size) vmalloc(size)
#define VFREE(mem) vfree(mem)

#define PRINT_UNFREE_MEM()

#endif

#endif // BC_MEM_H
