#ifndef __BC_DES
#define __BC_DES

#include "crypto/wintypes.h"

#define DES_ECB_ENCRYPT 0
#define DES_ECB_DECRYPT 1

/******* Exported functions *********/

#define KEY_LENGTH_DES          (64)
#define KEY_LENGTH_EXTENDED_DES (128*8)

BOOL
DES_KeyExtend( PUCHAR KeySource,          // 8       8-bit  uchars
               PDWORD KeyDestination );   // (128/4) 32-bit dwords


//
// Declaration of DES in ECB mode, necessary to:
// 1) test the DES implementation;
// 2) create Tripple DES implementation.
//

void DES_ECB_mode( BYTE  *Input,       /* 8 bytes of input data              */
                   BYTE  *Output,      /* 8 bytes of output data             */
                   DWORD *KeySchedule, /* [16][2] array of DWORDs            */ 
                   BYTE  Operation);    /* DES_ECB_ENCRYPT or DES_ECB_DECRYPT */


#endif
