#ifndef __BC_DES
#define __BC_DES

#include <crypto/wintypes.h>

#define SERVICE_NAME	"BC_DES"
#define DISPLAY_NAME    "DES"
#define BLOCK_LENGTH	 8
#define ALGORITHM_ID     0x40

// Key length in bits
#define KEY_LENGTH          (64)
#define KEY_LENGTH_EXTENDED (128*8)

#define DRIVER_MAJOR_VERSION	1
#define DRIVER_MINOR_VERSION	1

#define DES_ECB_ENCRYPT 0
#define DES_ECB_DECRYPT 1

/******* Exported functions *********/


BOOL
KeyExtend( PUCHAR KeySource,          // 8       8-bit  uchars
           PDWORD KeyDestination );   // (128/4) 32-bit dwords

/*VOID
Encrypt( DWORD *IVector, 
         DWORD *KeyAdress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length );    // in bytes

VOID
Decrypt( DWORD *IVector, 
         DWORD *KeyAdress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length );    // in bytes*/

void Encrypt_ECB( BYTE  *Input,        /* 8 bytes of input data              */
                  BYTE  *Output,       /* 8 bytes of output data             */
                  BYTE  *ExtendedKey); 


void Decrypt_ECB( BYTE  *Input,        /* 8 bytes of input data              */
                  BYTE  *Output,       /* 8 bytes of output data             */
                  BYTE  *ExtendedKey); 

#define BC_PLUGIN_NAME		SERVICE_NAME
#define BC_ALGORITHM_NAME	DISPLAY_NAME
#define BC_ALGORITHM_ID		ALGORITHM_ID
#define BC_KEY_LENGTH		KEY_LENGTH
#define BC_BLOCK_SIZE		BLOCK_LENGTH
#define BC_EXTENDED_KEY_SIZE	KEY_LENGTH_EXTENDED / 8

#endif

