#ifndef __BC_GOST
#define __BC_GOST

#include <crypto/wintypes.h>


#define SERVICE_NAME	"BC_Gost"
#define DISPLAY_NAME    "GOST"
#define BLOCK_LENGTH	8
#define ALGORITHM_ID	0xaa

// Key length in bits
#define KEY_LENGTH          (256)
#define KEY_LENGTH_EXTENDED (1024)

#define DRIVER_MAJOR_VERSION	1
#define DRIVER_MINOR_VERSION	1

// This cipher overrides CBC mode.
#define OVERRIDE_CBC

BOOL
KeyExtend( PUCHAR KeySource,          // 8  32-bit dwords
           PDWORD KeyDestination );   // 32 32-bit dwords


VOID
Encrypt( DWORD *IVector, 
         DWORD *KeyAdress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length );    // in bytes

VOID
Decrypt( DWORD *IVector, 
         DWORD *KeyAdress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length );    // in bytes


void Encrypt_ECB( BYTE *DataIn, BYTE *DataOut, BYTE *Context );

void Decrypt_ECB( BYTE *DataIn, BYTE *DataOut, BYTE *Context );

#define BC_PLUGIN_NAME		SERVICE_NAME
#define BC_ALGORITHM_NAME	DISPLAY_NAME
#define BC_ALGORITHM_ID		ALGORITHM_ID
#define BC_KEY_LENGTH		KEY_LENGTH
#define BC_BLOCK_SIZE		BLOCK_LENGTH
#define BC_EXTENDED_KEY_SIZE	KEY_LENGTH_EXTENDED / 8

#endif

