/*
 * Copyright 2010 Jetico, Inc. All rights reserved.
 * This file should provide standard int sizes and size_t.
 */

#ifndef BC_CRYPTO_INTSIZE_H
#define BC_CRYPTO_INTSIZE_H

#ifdef BC_LINUX
#include <linux/types.h>
#endif

//#include <stdint.h>
//#include <sys/types.h>


/// big-endian 128 bit type.
typedef struct bc_be128
{
	uint64_t	a;
	uint64_t	b;
} bc_be128;


#define BC_BE128_INIT { 0ull, 0ull }


/// xor two 128 big-endians and store result in res.
static inline void bc_be128_xor3(bc_be128* left, bc_be128* right, bc_be128* res)
{
	res->a = left->a ^ right->a;
	res->b = left->b ^ right->b;
}


/// xor two 128 big-endians and store result in second argument.
static inline void bc_be128_xor2(bc_be128* src, bc_be128* dst)
{
	dst->a ^= src->a;
	dst->b ^= src->b;
}



#endif
