/*
 *  Copyright 2010 Jetico, Inc. All rights reserved.
 *
 */

#ifndef BCBUS_CRYPTO_UTILS_H
#define BCBUS_CRYPTO_UTILS_H

#include "intsize.h"

// convert size in bits to bytes.
// used for cipher key size conversion by modes.
static inline unsigned bc_bits_to_bytes(unsigned bits) {
	return (bits + 7) >> 3;
}


// round a number of bytes up to the block boundary
// return a number of blocks.
static inline unsigned bc_ceil(unsigned value, unsigned blocksize) {
	return ((value + blocksize - 1) & ~(blocksize - 1));
}


// clamp a value down to block size.
// return limit or value if value was less then limit
static inline unsigned bc_clamp(unsigned value, unsigned limit) {
	return (value <= limit) ? value : limit;
}


#endif
