/*
 *	Copyright (c) 2010 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *  Password based key block encoding and decoding
 */

#ifndef KGGHOST_PBE_H
#define KGGHOST_PBE_H

#include "keyblock.h"

namespace kgghost {

    // Encode key into key block using password
    unsigned pbe_encode(const key_data_t* key, const BCPassword* pwd, char* kb_data, unsigned kbsize);
    
    // Decode key from key block using password
    unsigned pbe_decode(const char* kbdata, unsigned kbsize, const BCPassword* pwd,
                        BCCipher* cipher, int hash, key_data_t* out_key);

    // Verify password without decoding the key
    bool pbe_verify(const char* kbdata, unsigned kbsize, const BCPassword* pwd,
                    BCCipher* cipher, int hash);

}

#endif

