/*******************************************************************
 *
 *	Copyright (c) 1994-1999 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: kg_defs.h
 *	Revision:  $Id: kg_defs.h,v 1.2 2005-05-14 06:50:36 crypt Exp $
 *	Created:
 *	Description: declaration of error codes and flags
 *
 *******************************************************************/

#ifndef KGSHA_DEFS_H
#define KGSHA_DEFS_H


// ids that we report for container headers.
// there were two separate keygens once called kgsha and kgsha256.
// now there is only kgsha256 for both versions but we can still encounter container with old id.
enum {
	kKGSHA_ID		= 2,
	kKGSHA256_ID    = 3,
};


#define KGSHA_SIGNATURE98 	"LOCOS98"
#define KGSHA_SIGNATURE03 	"LOCOS03"
#define KGSHA_SIGNATURE04 	"LOCOS04"

#define FORMAT_VERSION		0x00000001

// kgsha limits.
enum {
	kKGSHA_KeySize		= 64,
	kKGSHA_DigestSize	= 32,
	kKGSHA_PoolSize		= 512,
	kKGSHA_TotalKeys	= 8,
	kKGSHA_SeedSize		= 128,
	kKGSHA_IVSize		= 8,
	
	kKGSHA_ContainerIdSize	= 4,
	kKGSHA_VerBufferSize	= 16,
	kKGSHA_VerBlockReserved	= kKGSHA_KeySize - (kKGSHA_ContainerIdSize + kKGSHA_VerBufferSize),
};

#endif

