/*
 *	Copyright Jetico, Oy, 2011.
 *	Common utilities.
 */

#ifndef BCMOUNT_COMMON_H
#define BCMOUNT_COMMON_H

// Get bcrypt device major number
int bc_get_dev_major(void);

// Elevate privileges
int bc_get_root(void);

// Drop priveleges
int bc_drop_root(void);

// Spawn new process with argument list. Returns only for parent the way fork(2) does.
int bc_spawn(const char* name, ...);

// Return 1 if specified device's major number is ours. Return 0 otherwise
int is_bc_device(dev_t dev);

// Tell if the current user owns this fs object.
int is_owner(const char* path);

#endif

