/*
 * Copyright (c) 2012 Jetico, Inc., Finland
 * All rights reserved.
 */

#ifndef DEFS_H
#define DEFS_H

#ifdef _WIN32
#error "TODO: Windows part is not implemented here."
#else
#ifdef BC_KERNEL // Linux, kernel-space level.

#define _NO_VERSION_

#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/slab.h>
#include <asm/uaccess.h>

typedef int8_t		bc_8;
typedef uint8_t		bc_u8;
typedef int16_t		bc_16;
typedef uint16_t	bc_u16;
typedef int32_t		bc_32;
typedef uint32_t	bc_u32;
typedef int64_t		bc_64;
typedef uint64_t	bc_u64;

#define FREE(p) kfree(p)
#define ALLOC(size) kmalloc(size, GFP_KERNEL)
#define PRINT(msg, args...) printk(KERN_ERR "bestcrypt: " msg, ##args)

#else // Linux, user-space level.

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

typedef int8_t		bc_8;
typedef uint8_t		bc_u8;
typedef int16_t		bc_16;
typedef uint16_t	bc_u16;
typedef int32_t		bc_32;
typedef uint32_t	bc_u32;
typedef int64_t		bc_64;
typedef uint64_t	bc_u64;

#ifndef __cplusplus
    #define bool int
    #define true 1
    #define false 0
#endif

#define FREE(p) free(p)
#define ALLOC(size) malloc(size)
#define PRINT(msg, args...) fprintf(stderr, msg, ## args);

#endif // BC_KERNEL
#endif // else

#endif // DEFS_H
