/*
 * Copyright (c) 2012 Jetico, Inc., Finland
 * All rights reserved.
 */

#include "extent.h"

bool ExtentUnion(Extent *result, const Extent *e1, const Extent *e2)
{
    bc_u64 start, end;

    if (ExtentAreIntersecting(e1, e2))
    {
        start = ExtentStart(e1) < ExtentStart(e2) ? ExtentStart(e1) : ExtentStart(e2);
        end = ExtentEnd(e1) > ExtentEnd(e2) ? ExtentEnd(e1) : ExtentEnd(e2);
        result->start = start;
        result->length = end - start + 1;
        return true;
    }

    return false;
}

