#ifndef ADDITIONALACTIONSWIDGET_H
#define ADDITIONALACTIONSWIDGET_H

#include <QWidget>

class QAction;
class QToolButton;

namespace Ui {
class AdditionalActionsWidget;
}

class ContainerDescriptor;

class AdditionalActionsWidget : public QWidget
{
    Q_OBJECT
    
public:

    explicit AdditionalActionsWidget(QWidget *parent = 0);
    ~AdditionalActionsWidget();

    void SetDescriptor(ContainerDescriptor *descriptor);

signals:
    void OnPasswordRemove();
    void OnPasswordAdd();
    void OnPasswordChange();
    void OnReencrypt();
    void OnBackupHeader();
    void OnRestoreHeader();
    void OnEncryptHeader();
    void OnDecryptHeader();
    void OnCreateHiddenPart();
    void OnLink();
    void OnFormat();
    void OnFsck();
    void OnShowLog();
    
private:
    void FillMenus();

    Ui::AdditionalActionsWidget *ui;

    // "Passwords" actions.
    QAction *_passwordsRemoveAction;
    QAction *_passwordsAddAction;
    QAction *_passwordsChangeAction;

    // "Backup" actions.
    QAction *_backupBackupHeaderAction;
    QAction *_backupRestoreHeaderAction;

    // "Advanced" actions.
    QAction *_advancedReencryptAction;
    QAction *_advancedFsckAction;
    QAction *_advancedFormatAction;
    QAction *_advancedLinkAction;
    QAction *_advancedShowLogAction;
    QAction *_advancedEncryptHeaderAction;
    QAction *_advancedDecryptHeaderAction;
    QAction *_advancedCreateHiddenAction;
};

#endif // ADDITIONALACTIONSWIDGET_H
