#ifndef CONTAINERINFOWIDGET_H
#define CONTAINERINFOWIDGET_H

#include <QWidget>

class ContainerDescriptor;
class AdditionalActionsWidget;

namespace Ui {
class ContainerInfoWidget;
}

class ContainerInfoWidget : public QWidget
{
    Q_OBJECT
    
public:
    explicit ContainerInfoWidget(QWidget *parent = 0);
    ~ContainerInfoWidget();

    void SetData(ContainerDescriptor *descriptor);
    QString GetMountLocation();
    void SetMountLocation(const QString& mountLocation);
    bool NeedMountReadOnly();

    /**
      @brief Method created to avoid duplicating of large amount of signals.
    */
    const AdditionalActionsWidget *GetAdditionalActionsWidget();

signals:
    void OnCreate();
    void OnBrowse();
    
protected:
    void resizeEvent(QResizeEvent *);

private slots:
    void on_createButton_clicked();

    void on_browseButton_clicked();

    void on_mountLocationButton_clicked();

    void OnMountPointLocationChangedSlot(QString text);

    void OnMountReadOnlyCheckStateChangedSlot(int state);

    void OnOpenMountLocationSlot();

private:
    Ui::ContainerInfoWidget *ui;

    ContainerDescriptor *descriptor_;

    void UpdateContainerInfo(ContainerDescriptor *descriptor);
};

#endif // CONTAINERINFOWIDGET_H
