#ifndef CONTAINERTREEWIDGET_H
#define CONTAINERTREEWIDGET_H

#include "containerview.h"

#include <QWidget>

namespace Ui {
class ContainerTreeWidget;
}

class ContainerModel;
class ContainerDescriptor;

class ContainerTreeWidget : public QWidget
{
    Q_OBJECT
    
public:
    explicit ContainerTreeWidget(QWidget *parent = 0);
    ~ContainerTreeWidget();
    void InitModel(ContainerModel *model);

    ContainerDescriptor *GetSelectedDescriptor()
    {
        if (this->selectedView_)
            return this->selectedView_->GetDescriptor();
        return 0;
    }

    // bool SelectContainer(const QString& fullPath);
    bool SelectDescriptor(ContainerDescriptor *descriptor);
    void UpdateCurrentView();

signals:
    void OnSelectedDescriptorChanged(ContainerDescriptor *descriptor);
    void OnEject();
    void OnMount();
    void OnDelete();

protected:
    void keyPressEvent(QKeyEvent *event);

private slots:
    void SelectedViewChangedSlot(ContainerView *view);
    void SelectedViewEjectClickedSlot(ContainerView *view);
    void SelectedViewMountClickedSlot(ContainerView *);
    void SelectedViewSelectNextSlot(ContainerView *view);
    void SelectedViewSelectPreviousSlot(ContainerView *view);
    void DataChangedSlot();
    void ClearButtonClickSlot();
    void RemoveButtonClickedSlot();

private:
    Ui::ContainerTreeWidget     *ui;

    ContainerModel              *containerModel_;
    QList<ContainerView *>      *containerViews_;
    ContainerView               *selectedView_;
    QAction                     *deleteFileAction_;
    QAction                     *clearListAction_;

    void SelectView(ContainerView *view);
    void UpdateViewList();
    void SelectContainerByIndex(int index);
};

#endif // CONTAINERTREEWIDGET_H
