#ifndef CONTAINERVIEW_H
#define CONTAINERVIEW_H

#include <QWidget>

namespace Ui {
class ContainerView;
}

class ContainerDescriptor;

class ContainerView : public QWidget
{
    Q_OBJECT
    
public:
    explicit ContainerView(QWidget *parent = 0);
    ~ContainerView();

    void SetDescriptor(ContainerDescriptor *d);
    ContainerDescriptor *GetDescriptor()
    {
        return this->descriptor_;
    }

    void Select();
    void Deselect();
    bool IsSelected()
    {
        return this->isSelected_;
    }

    void UpdateView();

    void paintEvent(QPaintEvent *);
    void mouseDoubleClickEvent(QMouseEvent *);
    void keyPressEvent(QKeyEvent *);

signals:
    void OnSelected(ContainerView* w);
    void OnEject(ContainerView *w);
    void OnMount(ContainerView *w);
    void OnSelectNext(ContainerView *w);
    void OnSelectPrevious(ContainerView *w);

protected:
    void mousePressEvent(QMouseEvent *);

private:
    Ui::ContainerView *ui;
    bool isSelected_;
    ContainerDescriptor *descriptor_;

private slots:
    void EjectClickSlot();
};

#endif // CONTAINERVIEW_H
