#ifndef CREATEDIALOG_H
#define CREATEDIALOG_H

#include <QMainWindow>
#include <QDialog>

#include "kernel/BCKernel.h"

namespace Ui {
class CreateDialog;
}

class ContainerDescriptor;

class CreateDialog : public QDialog
{
    Q_OBJECT
    
public:
    explicit CreateDialog(QWidget *parent = 0);
    ~CreateDialog();

    /**
        @brief Returns container descriptor for new container.
        @warning Result is needed to be deleted by caller.
    */
    ContainerDescriptor *GetData();

    bool HaveResult()
    {
        return this->haveResult_;
    }

    void ResetResult()
    {
        this->haveResult_ = false;
    }

    QDialog::DialogCode GetResult();

private:
    Ui::CreateDialog *ui;
    QList<BCAlgInfo> *algList_;
    QDialog::DialogCode dialogResult_;
    bool haveResult_;

    void FillControls();

private slots:
    //void OnBrowseButtonSlot();
    void OnAdvancedCheckBoxCheckedSlot(bool checked);

    void OnOkSlot();
    void OnCancelSlot();
};

#endif // CREATEDIALOG_H
