#include "hotkey.h"

#define HAVE_MODIFIER(mods, mod) ((mods & mod) == mod)

static QString GetModifierString(Qt::KeyboardModifiers modifiers)
{
    QString result;
    if (HAVE_MODIFIER(modifiers, Qt::ControlModifier))
        result += "Ctrl";

    if (HAVE_MODIFIER(modifiers, Qt::ShiftModifier))
        result += result.length()? QString("+Shift") : QString("Shift");

    if (HAVE_MODIFIER(modifiers, Qt::AltModifier))
        result += result.length()? QString("+Alt") : QString("Alt");

    if (HAVE_MODIFIER(modifiers, Qt::MetaModifier))
        result += result.length()? QString("+Meta") : QString("Meta");

    return result;
}

QString BCHotkey::ToString() const
{
    QKeySequence mainKey(this->mainKey);
    QString modifiersString = GetModifierString(this->modifiers);
    return modifiersString + QString("+") + mainKey.toString(QKeySequence::NativeText);
}
