#include "formatdialog.h"
#include "ui_formatdialog.h"

#include "model/helper.h"

FormatDialog::FormatDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::FormatDialog)
{
    ui->setupUi(this);

    connect(this->ui->cancelButton, SIGNAL(clicked()), this, SLOT(CancelButtonSlot()));
    connect(this->ui->okButton, SIGNAL(clicked()), this, SLOT(OkButtonSlot()));
    connect(this, SIGNAL(rejected()), this, SLOT(CancelButtonSlot()));
    this->ui->fsWidget->ReloadFilesystems(false);
    BCHelperFixSize(this);
    this->ResetResult();
}

QString FormatDialog::GetFileSystem()
{
    return this->ui->fsWidget->GetFileSystem();
}

void FormatDialog::OkButtonSlot()
{
    this->result_ = QDialog::Accepted;
    this->haveResult_ = true;
}

void FormatDialog::CancelButtonSlot()
{
    this->result_ = QDialog::Rejected;
    this->haveResult_ = true;
}

FormatDialog::~FormatDialog()
{
    delete ui;
}
