#include "logdialog.h"
#include "ui_logdialog.h"

#include "model/logging.h"

#include <QScrollBar>

LogDialog::LogDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::LogDialog)
{
    ui->setupUi(this);

    this->OnRefreshSlot();

    connect(this->ui->refreshButton, SIGNAL(clicked()), this, SLOT(OnRefreshSlot()));
    connect(this->ui->closeButton, SIGNAL(clicked()), this, SLOT(close()));
    connect(this->ui->clearButton, SIGNAL(clicked()), this, SLOT(OnClearSlot()));
}

LogDialog::~LogDialog()
{
    delete ui;
}

void LogDialog::OnClearSlot()
{
    BCLogClear();
    this->OnRefreshSlot();
}

void LogDialog::OnRefreshSlot()
{
    // Reload log.
    BCLogUpdate();

    // Set log contents to the control.
    this->ui->plainTextEdit->clear();
    QString logText = BCLogGetText();
    this->ui->plainTextEdit->appendPlainText(logText);

    // Scroll to the end of the log.
    QScrollBar *verticalScroll = this->ui->plainTextEdit->verticalScrollBar();
    verticalScroll->setValue(verticalScroll->maximum());
}
