#include "mainwindow.h"
#include "src/version.h"
#include "bcapplication.h"

#include <QtGui/QApplication>
#include <QtGui/QMessageBox>

#include <fcntl.h>
#include <sys/stat.h>
#include <semaphore.h>

#include "container/user.h"
#include "model/logging.h"


const char *PROG_NAME = "bestcrypt-gui";

int main(int argc, char *argv[])
{
    BCLogStart();
    QCoreApplication::setOrganizationName(BC_VENDOR);
    QCoreApplication::setOrganizationDomain(BC_DOMAIN);
    QCoreApplication::setApplicationName(BC_GUI_APP_NAME);

    BCApplication a(argc, argv);
    a.setQuitOnLastWindowClosed(false);

    // Check if we need to process some files.
    if (a.NeedProcessArgs())
    {
        // Process files and exit application.
        return a.ProcessArgs();
    }

    // Check that only one instance is running.
    a.CheckOneInstance();

    MainWindow w;
    w.show();

    a.exit(0);
    return a.exec();
}
