#include "maintoolbarwidget.h"
#include "ui_maintoolbarwidget.h"

MainToolbarWidget::MainToolbarWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::MainToolbarWidget)
{
    ui->setupUi(this);

    connect(this->ui->createToolButton, SIGNAL(clicked()), this, SLOT(CreateClickedSlot()));
    connect(this->ui->locateToolButton, SIGNAL(clicked()), this, SLOT(BrowseClickedSlot()));
    connect(this->ui->mountToolButton, SIGNAL(clicked()), this, SLOT(MountClickedSlot()));
    connect(this->ui->ejectToolButton, SIGNAL(clicked()), this, SLOT(EjectClickedSlot()));
    connect(this->ui->ejectAllToolButton, SIGNAL(clicked()), this, SLOT(EjectAllClickedSlot()));
    connect(this->ui->forceEjectToolButton, SIGNAL(clicked()), this, SLOT(EjectForceClickedSlot()));
}
//void MainToolbarWidget::InitAdditionalActions()
//{
//    this->rawLinkAction_ = new QAction(tr("Raw Link"), this->ui->mountToolButton);

//    // TODO: raw link is disabled here due to handler is not implemented.
//    this->rawLinkAction_->setVisible(false);

//    connect(this->rawLinkAction_, SIGNAL(triggered()), this, SLOT(OnRawLinkClickedSlot()));

//    // Set images for actions.
//    QImage linkImage(":/icons/Link");
//    if (!linkImage.isNull())
//    {
//        QPixmap linkPmp = QPixmap::fromImage(linkImage);
//        QIcon icon(linkPmp);
//        this->rawLinkAction_->setIcon(icon);
//    }

//    this->ui->mountToolButton->addAction(this->rawLinkAction_);
//    this->ui->mountToolButton->setPopupMode(QToolButton::MenuButtonPopup);
//}

MainToolbarWidget::~MainToolbarWidget()
{
    delete ui;
}

void MainToolbarWidget::SetMountEnabled(bool enabled)
{
    this->ui->mountToolButton->setEnabled(enabled);
}

void MainToolbarWidget::SetEjectEnabled(bool enabled)
{
    this->ui->ejectToolButton->setEnabled(enabled);
    this->ui->forceEjectToolButton->setEnabled(enabled);
}

void MainToolbarWidget::SetEjectAllEnabled(bool enabled)
{
    this->ui->ejectAllToolButton->setEnabled(enabled);
}

void MainToolbarWidget::CreateClickedSlot()
{
    emit this->OnCreate();
}

void MainToolbarWidget::BrowseClickedSlot()
{
    emit this->OnBrowse();
}

void MainToolbarWidget::MountClickedSlot()
{
    emit this->OnMount();
}

void MainToolbarWidget::EjectClickedSlot()
{
    emit this->OnEject();
}

void MainToolbarWidget::EjectForceClickedSlot()
{
    emit this->OnEjectForce();
}

void MainToolbarWidget::EjectAllClickedSlot()
{
    emit this->OnEjectAll();
}
