#ifndef MAINTOOLBARWIDGET_H
#define MAINTOOLBARWIDGET_H

#include <QWidget>

namespace Ui {
class MainToolbarWidget;
}

class ContainerDescriptor;

class MainToolbarWidget : public QWidget
{
    Q_OBJECT
    
public:
    explicit MainToolbarWidget(QWidget *parent = 0);
    ~MainToolbarWidget();
    void SetMountEnabled(bool enabled);
    void SetEjectEnabled(bool enabled);
    void SetEjectAllEnabled(bool enabled);

signals:
    void OnCreate();
    void OnBrowse();
    void OnMount();
    void OnEject();
    void OnEjectForce();
    void OnEjectAll();

private:
    Ui::MainToolbarWidget   *ui;
    QAction                 *rawLinkAction_;


private slots:
    void CreateClickedSlot();
    void BrowseClickedSlot();
    void MountClickedSlot();
    void EjectClickedSlot();
    void EjectForceClickedSlot();
    void EjectAllClickedSlot();
};

#endif // MAINTOOLBARWIDGET_H
