#ifndef HOTKEYLISTENER_H
#define HOTKEYLISTENER_H

#include <QObject>
#include <QKeySequence>

#include "entity/hotkey.h"

class HotkeyListener : public QObject
{
    Q_OBJECT

public:
    HotkeyListener();
    ~HotkeyListener();

    bool SetHotkey(const BCHotkey& hotkey);

    bool StartListening();

    bool StopListening();

    bool IsListening()
    {
        return this->isListening_;
    }

    bool eventFilter(QObject */*watched*/, QEvent *event);

signals:
    void OnHotkeyPressed();

private:
    bool isListening_;
    bool isInitialized_;
    Qt::Key mainKey_;
    Qt::KeyboardModifiers modifiers_;
};

#endif // HOTKEYLISTENER_H
