#ifndef PASSWORDDIALOG_H
#define PASSWORDDIALOG_H

#include <QDialog>
#include <QMainWindow>
#include "container/user.h"

namespace Ui {
class PasswordDialog;
}

class PasswordDialog : public QDialog
{
    Q_OBJECT
    
public:
    explicit PasswordDialog(QWidget *parent = 0);
    ~PasswordDialog();
    void SetPasswordPromptText(const QString& text);
    void SetConfirmVisible(bool visible);
    void ShowError(const QString& error);

    bool HaveResult()
    {
        return this->haveResult_;
    }

    BCUserResult GetResult()
    {
        return this->result_;
    }

    void ResetResult()
    {
        this->haveResult_ = false;
        this->result_ = kBCUserCancel;
        if (this->password_)
            this->password_->clear();
        this->SetButtonsEnabled(true);
    }

    void SetMountParams(BCMountParams *params);

    void SetPasswordBuffer(BCPassword *password);

private:
    Ui::PasswordDialog *ui;
    BCPassword         *password_;
    BCMountParams      *mountParams_;
    BCUserResult        result_;
    bool                haveResult_;

    void SetButtonsEnabled(bool enabled);
    void MountParamsToStruct();
private slots:
    void OnCancelSlot();
    void OnOkSlot();
    void OnRejectSlot();
    void OnPassTextChangedSlot();
    void on_mountLocationButton_clicked();
};

#endif // PASSWORDDIALOG_H
