#include "rawlinkdialog.h"
#include "ui_rawlinkdialog.h"

RawLinkDialog::RawLinkDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::RawLinkDialog)
{
    ui->setupUi(this);

    connect(this->ui->okButton, SIGNAL(clicked()), this, SLOT(AcceptSlot()));
    connect(this->ui->cancelButton, SIGNAL(clicked()), this, SLOT(RejectSlot()));
}

RawLinkDialog::~RawLinkDialog()
{
    delete ui;
}

void RawLinkDialog::SetParameters(RawLinkParameters *p)
{
    this->parameters = p;
    if (p)
    {
        QString windowTitle = QString("Raw Link of %0").arg(p->file);
        this->setWindowTitle(windowTitle);
    }
}

void RawLinkDialog::AcceptSlot()
{
    if (this->parameters)
    {
        this->parameters->algId = this->ui->cipherWidget->GetAlgorythmId();
        this->parameters->algName = this->ui->cipherWidget->GetAlgorythmName();
        this->parameters->modeName = this->ui->cipherWidget->GetModeName();

        this->accept();
    }
    else
    {
        qDebug("Parameters are not set inside raw link dialog.\n");
        this->reject();
    }
}

void RawLinkDialog::RejectSlot()
{
    this->reject();
}
