#include "reencryptdialog.h"
#include "ui_reencryptdialog.h"

#include "model/bcoperation.h"
#include "model/helper.h"

ReencryptDialog::ReencryptDialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::ReencryptDialog)
{
    ui->setupUi(this);

    connect(this->ui->okButton, SIGNAL(clicked()), this, SLOT(OkSlot()));
    connect(this->ui->cancelButton, SIGNAL(clicked()), this, SLOT(CancelSlot()));
    this->ResetResult();
}

ReencryptDialog::~ReencryptDialog()
{
    delete ui;
}

QString ReencryptDialog::GetAlgorythmName()
{
    return this->ui->cipherWidget->GetAlgorythmName();
}

bc_alg_id ReencryptDialog::GetAlgorythmId()
{
    return this->ui->cipherWidget->GetAlgorythmId();
}

QString ReencryptDialog::GetModeName()
{
    return this->ui->cipherWidget->GetModeName();
}

void ReencryptDialog::OkSlot()
{
    this->result_ = Accepted;
    this->haveResult_ = true;
}

void ReencryptDialog::CancelSlot()
{
    this->result_ = Rejected;
    this->haveResult_ = true;
}
