#ifndef REENCRYPTDIALOG_H
#define REENCRYPTDIALOG_H

#include <QDialog>
#include "kernel/BCKernel.h"

namespace Ui {
class ReencryptDialog;
}

class ReencryptDialog : public QDialog
{
    Q_OBJECT
    
public:
    explicit ReencryptDialog(QWidget *parent = 0);
    ~ReencryptDialog();

    QString GetAlgorythmName();
    bc_alg_id GetAlgorythmId();
    QString GetModeName();

    bool HaveResult()
    {
        return this->haveResult_;
    }

    DialogCode GetResult()
    {
        return this->result_;
    }

    void ResetResult()
    {
        this->haveResult_ = false;
    }
    
private:
    Ui::ReencryptDialog *ui;
    bool haveResult_;
    DialogCode result_;

private slots:
    void OkSlot();
    void CancelSlot();
};

#endif // REENCRYPTDIALOG_H
