#ifndef SELECTCIPHERWIDGET_H
#define SELECTCIPHERWIDGET_H

#include "kernel/BCKernel.h"

#include <QWidget>

namespace Ui {
class SelectCipherWidget;
}

class SelectCipherWidget : public QWidget
{
    Q_OBJECT
    
public:
    explicit SelectCipherWidget(QWidget *parent = 0);
    ~SelectCipherWidget();

    QString GetAlgorythmName();
    QString GetModeName();
    bc_alg_id GetAlgorythmId();

private slots:
    void OnSelectedAlgChangedSlot(int index);
    
private:
    void FillAlgList();
    void AddModeIfSupported(BCAlgInfo &alg, bc_mode_id mode);

    Ui::SelectCipherWidget *ui;

    QList<BCAlgInfo> *algList_;
};

#endif // SELECTCIPHERWIDGET_H
