#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H

#include <QDialog>

#include "entity/settings.h"

namespace Ui {
class SettingsDialog;
}

class SettingsDialog : public QDialog
{
    Q_OBJECT
    
public:
    explicit SettingsDialog(QWidget *parent = 0);
    ~SettingsDialog();

private slots:
    void OnHotKeyChangeSlot();
    void OnConfigEnabledCheckedSlot(bool set);
    void OnAcceptSlot();
    void OnCancelSlot();
    
private:
    Ui::SettingsDialog *ui;
    BCSettings          settings;

    void LoadSettings();
    void SaveSettings();
    void DisplayHotkeyString(const BCHotkey& hotkey);
};

#endif // SETTINGSDIALOG_H
