#ifndef TESTS_INIT_C
#define TESTS_INIT_C

#include "../tests-common.c"

void TestBCKernelIsInitialized(void)
{
    // Assume that running from install script and kernel module is not installed yet.
    bc_kern_result result = BCKernelIsInitialized();
    CU_ASSERT(result == kBCKernel_NotInitialized);
    
    InstallBCKernel();    
        
    result = BCKernelIsInitialized();
    CU_ASSERT(result == kBCKernel_Success);
    
    UninstallBCKernel();
    
    result = BCKernelIsInitialized();
    CU_ASSERT(result == kBCKernel_NotInitialized);
}

#endif
