#include "../tests-common.c"

static void ReadSizes(int *buffer)
{
    FILE *out = fopen("out.txt", "r");
    CU_ASSERT_FATAL(NULL != out);
    CU_ASSERT(4 == fscanf(out, "%i\n%i\n%i\n%i", &buffer[0], &buffer[1], &buffer[2], &buffer[3]));
    fclose(out);
    remove("out.txt");
}

static void CompileAndRun(const int arch_param)
{
    int sys_result = 0;
    switch(arch_param)
    {
        case 32:
            sys_result = system("gcc -o print-size print-struct-size.c -m32");
            break;
        case 64:
            sys_result = system("gcc -o print-size print-struct-size.c -m64");
            break;
        default:
            CU_FAIL_FATAL("Unknown arch param specified.");
            break;
    }
    if (sys_result)
    {
        CU_FAIL_FATAL("Child program compilation failed.");
    }
    sys_result = system("./print-size");
    CU_ASSERT(!sys_result);
}

void TestStructSize()
{
    int sizes32[4], sizes64[4], i;
    
    CompileAndRun(64);
    ReadSizes(sizes64);
    
    CompileAndRun(32);
    ReadSizes(sizes32);
    
    for (i=0; i<4; i++)
    {
        if (sizes32[i] != sizes64[i])
        {
            CU_FAIL("Struct sizes are not equal.");
            return;
        }
    }
}
